'use strict';

exports.__esModule = true;
exports.getNewestReg = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

/**
 * Get newest service worker registration
 *
 * @return {Promise<ServiceWorkerRegistration>}
 */
/* istanbul ignore next: unable to test it on single run */
var getNewestReg = function () {
  var _ref = _asyncToGenerator(_regenerator2.default.mark(function _callee() {
    var _navigator, serviceWorker, registration, newWorker;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _navigator = navigator, serviceWorker = _navigator.serviceWorker;


            updateLog.color('darkorchid').info('checking for updates');

            _context.next = 4;
            return serviceWorker.getRegistration();

          case 4:
            registration = _context.sent;

            if (registration) {
              _context.next = 7;
              break;
            }

            throw new Error('no active service worker registration is found');

          case 7:
            _context.next = 9;
            return registration.update();

          case 9:
            newWorker = registration.installing || registration.waiting;

            if (!newWorker) {
              _context.next = 16;
              break;
            }

            updateLog.info('installing updates');

            // wait until worker is activated
            _context.next = 14;
            return (0, _utils.eventWaitUntil)(newWorker, 'statechange', function () {
              return newWorker.state === 'activated';
            });

          case 14:
            _context.next = 17;
            break;

          case 16:
            updateLog.color('lightseagreen').info('already up-to-date');

          case 17:
            return _context.abrupt('return', registration);

          case 18:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function getNewestReg() {
    return _ref.apply(this, arguments);
  };
}();

var _utils = require('../../utils/');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var updateLog = _utils.debug.scope('update');exports.getNewestReg = getNewestReg;
//# sourceMappingURL=get-newest-reg.js.map